#!/usr/bin/env python
# -*- coding: utf-8 -*-
#监控堡垒机连通性


import os,json,re
from influxdb import InfluxDBClient
import http.client
import paramiko


class jmsConnet:
    def __init__(self):
        self.keyFile = ""
        self.dbName = ""
        self.assetsInfo = []
        self.dbClient = ""

        # 白名单列表
        self.whiteList = []

    def getJmsIp(self):
        try:
            ipRes = os.popen("hostname -I")
            ipList = ipRes.read().split(" ")
            if "10.14.3.11" in ipList:
                self.keyFile = "/root/.ssh/id_rsa"
                self.dbName = "tx_jums_new"
        except Exception as e:
            print(e)

    def initInfluxdb(self):
        try:
            client = InfluxDBClient("10.14.3.127", "8086", "root", "", 'sa')
            dbcmd = "drop measurement %s;" %self.dbName
            client.query(dbcmd)
        except Exception as ex:
            print("influxdb ERROR: %s") % ex
            client = InfluxDBClient("10.14.3.127", "8086", "root", "", 'sa')
        self.dbClient = client

    def writeInfluxdb(self,i):
        ip = i["ip"]
        gysn = i["gysn"]
        main_name = i["main_name"]
        error = i["error"]
        flag = i["flag"]
        client = i["client"]
        json_data = [
            {
                "measurement": self.dbName,
                "tags": {
                    "host_ip": ip,
                    "main_name": main_name,
                    "GYSN": gysn,
                    "error": error,
                },
                "fields": {
                    "flag": flag
                }
            }
        ]
        client.write_points(json_data)

    def getCenterHost(self):
        try:
            assets_info = []
            ip_list = []
            url = "simba.gyyx.cn"
            uri = "/centerapp/v1/base/get_jumpserver_assets_info"
            conn = http.client.HTTPConnection(url)
            conn.request(method="GET", url="http://" + url + uri)
            response = conn.getresponse()
            ress = response.read()
            resultsDict = json.loads(json.loads(ress)['data'])
            for i in resultsDict:
                if i["ip"].startswith("10.12.50"): continue
                if i["ip"].startswith("10.12.54"): continue
                if re.search("9003|86|5003", i["main_id"]) or re.search('3374', i["sub_id"]): continue
                if re.search("^WIN", i["os"]) or re.search("^TMRDS|^WB|^a502", i["gysn"]): continue
                if ip_list.count(i["ip"]): continue
                ip_list.append(i["ip"])
                if i["ip"].startswith("10.11."):
                    res = {}
                    res["ip"] = i["ip"]
                    res["gysn"] = i["gysn"]
                    res["main"] = i["main_name"]
                    assets_info.append(res)
            self.assetsInfo = assets_info
            print(self.assetsInfo)
        except Exception as e:
                print(e)

    def sshConnect(self):
        l = []
        for i in self.assetsInfo:
            d = {}
            try:
                sshClient = paramiko.SSHClient()
                sshClient.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                key_file = paramiko.RSAKey.from_private_key_file(self.keyFile)
                sshClient.connect(i["ip"], 63008, username="root", pkey=key_file, timeout=15)
                stdin, stdout, stderr = sshClient.exec_command("hostname")
                result = stdout.readlines()
                if not result:
                    if i["gysn"] in self.whiteList:continue
                    d["ip"] = i["ip"]
                    d["gysn"] = i["gysn"]
                    d["main_name"] = i["main"]
                    d["flag"] = 1
                    d["error"] = stderr.read()
                    d["client"] = self.dbClient
                    l.append(d)
            except Exception as e:
                if i["gysn"] in self.whiteList:continue
                d["ip"] = i["ip"]
                d["gysn"] = i["gysn"]
                d["main_name"] = i["main"]
                d["flag"] = 1
                d["error"] = e
                d["client"] = self.dbClient
                l.append(d)
            finally:
                self.dbClient.close()
        if l:
            for i in l:
                self.writeInfluxdb(i)
                print(i)
        else:
            i = {"ip": "none", "gysn": "none", "main_name": "none", "flag": 0, "error": "", "client": self.dbClient}
            self.writeInfluxdb(i)
            print(i)

if __name__ == '__main__':
    jmsConnetOb = jmsConnet()

    # 获取本机地址，判断是腾讯云堡垒机还是502堡垒机,并初始化相关数据
    jmsConnetOb.getJmsIp()

    # 初始化数据库
    jmsConnetOb.initInfluxdb()

    # 获取中心数据
    jmsConnetOb.getCenterHost()

    # 检测逻辑，ssh连接后执行hostname命令判断，失败的写入数据库
    jmsConnetOb.sshConnect()

